/*
	Sprankle Character Map - Inline, dynamic character map.
    Copyright (C) 2004  Steven Wittens

	see LICENSE.TXT for license.
*/
#include "sprankle.h"

vector<SprankleTable> table;

void SprankleTable::InitTable() {
	SprankleTable t(0);
	FILE *f = fopen("sprankle.txt", "rb");
	if (f) {
		wchar_t *data;
		fseek(f, 0, SEEK_END);
		long size = ftell(f);
		data = new wchar_t[size / 2];
		fseek(f, 0, SEEK_SET);
		fread(data, 1, size, f);
		fclose(f);

		bool add = false;
		for (int i = 1; i < size/2; ++i) {
			if (data[i] == '[') {
				if (t.source != 0) table.push_back(t);
				t.source = data[++i];
				t.dest.clear();
			}
			if (i >= size/2) break;
			if (data[i] == ']') {
				wchar_t ar[32];
				int arl = 0;
				while (data[i++] != '\n') { if (i >= size/2) break; };
				if (i >= size/2) break;
				while (data[i] != '[') {
					if ((data[i] != '\r') && (data[i] != '\n') && (data[i] != ' ')) {
						ar[arl++] = data[i];
					}
					else if (data[i] == '\n') {
						if (arl > 0) {
							ar[arl++] = 0;
							t.dest.push_back(ar);
							add = true;
						}
						else {
							add = false;
						}
						arl = 0;
					}
					++i;
					if (i >= size/2) break;
				}
				--i;
			}
			if (i >= size/2) break;
		}
		if (t.source != 0 && add) table.push_back(t);
		delete[] data;
	}
}